
<div class="container-fluid row">
    <div class="col-md-3">
        <div class="side-card">
            <img class="side-icon" src="../assets/reservation.png" alt="SVG Image" style="filter: hue-rotate(120deg);">
            <div style="margin-left: 20px;">
                <span>
                    <b>
                        {{ orderId }}
                    </b>
                </span>
                <p>Order Id</p>
            </div>
        </div>
        <div class="side-card">
            <img class="side-icon" src="../assets/invoice.png" alt="SVG Image">
            <div style="margin-left: 20px;">
                <span style="font-size: x-large;">
                    hello, <b> {{userName}} </b>
                </span>
            </div>
        </div>
    </div>
    <div class="col-md-3">
        <div style="display: flex; justify-content: space-around;">
            <!-- edit icon -->
            <div style="margin: 3px;">
                <img class="package-icons device_id" (click)="showeEditPackageModal()" src="../assets/arrow-edit.svg">
            </div>
            <!-- edit package pop up modal start-->
            <div class="modal" id="editPackageModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <label style="text-align:left; font-size: 15px; flex-grow: 1;">Edit Package Name</label>
                            <button type="button" (click)="closeEditPackageModal()" class="close btn-danger"
                                aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <form [formGroup]="editPackageNameForm" (ngSubmit)="editPackageName()">
                                <!-- select package to update -->
                                <select class="form-control" style="min-height: 45px; height: 3vw;"
                                    formControlName="package" name="package">
                                    <option value="" disabled selected>Select Package</option>
                                    <option value="{{package.packageUid}}" *ngFor="let package of allPackages">{{
                                        package.packageName }}</option>
                                </select>
                                <span *ngIf="package && package.invalid && package.touched"
                                    style="min-height: 45px; color: red">Please
                                    select the old package name and updated package
                                    name
                                </span>
                                <br>
                                <!-- package name textbox -->
                                <input class="form-control" formControlName="updatedPackageName" type="text"
                                    placeholder="New Package Name" width="100%" style="min-height: 45px; height:3vw"
                                    autocomplete="off">
                                <span
                                    *ngIf="updatedPackageName && updatedPackageName.invalid && updatedPackageName.touched"
                                    style="color: red; min-height: 45px;">Please select the old package name and updated
                                    package
                                    name</span>
                                <br>
                                <div class="modal-footer" style="padding: 6px !important;">
                                    <button type="button"
                                        style="width: 100px; height: 40px;align-self: center; box-shadow: 0 2px 8px rgb(0 0 0 / 20%);"
                                        (click)="closeEditPackageModal()" class="btn">Close</button>
                                    <button type="button" [disabled]="editPackageNameForm.invalid"
                                        (click)="editPackageName()"
                                        style="width: 150px; height: 40px;align-self: center;"
                                        class="btn btn-primary">Rename Package</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!-- edit package pop up modal end -->

            <!-- delete icon -->
            <div style="margin: 3px;" (click)="deletePackage()">
                <img class="package-icons" src="../assets/delete.png">
            </div>

            <!-- add new package icon -->
            <div class="tooltip-button" style="margin: 3px;">
                <div class="tooltip">Click to add new package</div>
                <img class="package-icons" (click)="createPackage()" src="../assets/add-pack.svg" alt="">
            </div>
            <!-- create new package pop up modal -->
            <div class="modal" id="createNewPackage" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <label style="text-align:left; font-size: 15px; flex-grow: 1;">Add Package</label>
                            <button type="button" (click)="closePackageModal()" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <form [formGroup]="addNewPackageForm" (ngSubmit)="addNewPackage()">
                                <!-- package dropdown -->
                                <select class="form-control" formControlName="packageType" name="packageType"
                                    style="width: 100%; height:3vw; min-height: 45px;">
                                    <option value="" selected default>Select Package Type</option>
                                    <option value="{{item.uid}}" *ngFor="let item of packageTypes">{{ item.package_type
                                        }}</option>
                                </select>
                                <span *ngIf="packageType && packageType.invalid && packageType.touched"
                                    style="color: red;">Select the type of package</span>
                                <br>
                                <!-- upc dropdown -->
                                <select class="form-control" formControlName="upc" name="package"
                                    style="height:3vw; width:100%; min-height: 45px;">
                                    <option [value]="undefined" selected default>Select UPC Code</option>
                                    <option style="height: 3vw" *ngFor="let item of upcCode">{{ item }}</option>
                                </select>
                                <span *ngIf="upcForm && upcForm.invalid && upcForm.touched" style="color: red;">Select
                                    the
                                    UPC</span>
                                <br>
                                <!-- package name textbox -->
                                <input class="form-control" formControlName="newPackageName" type="text"
                                    id="package_name" placeholder="Package Name" width="100%"
                                    style="min-height: 45px; height:3vw" autocomplete="off">
                                <span *ngIf="newPackageName && newPackageName.invalid && newPackageName.touched"
                                    style="color: red;">Insert the package name</span>
                                <br>
                                <!-- package weight textbox -->
                                <input class="form-control" formControlName="newPackageWeight" type="text"
                                    id="package_weight" placeholder="Package Weight" width="100%"
                                    style="min-height: 45px; height:3vw" autocomplete="off">
                                <span *ngIf="newPackageWeight && newPackageWeight.invalid && newPackageWeight.touched"
                                    style="color: red;">Insert package weight</span>
                                <br>
                                <div class="modal-footer" style="padding: 6px !important;">
                                    <button type="button"
                                        style="width: 100px; height: 40px;align-self: center; box-shadow: 0 2px 8px rgb(0 0 0 / 20%);"
                                        (click)="closePackageModal()" class="btn" data-dismiss="modal">Close</button>
                                    <button type="button" [disabled]="addNewPackageForm.invalid"
                                        style="width: 131px; height: 40px;align-self: center;" (click)="addNewPackage()"
                                        class="btn btn-primary">Add Package</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!-- end new package pop up modal -->
        </div>
        <!-- scan form -->
        <form [formGroup]="scanForm" (ngSubmit)="scannedSerialNumbers()">
            <!-- package dropdown -->
            <select class="form-control" formControlName="package" (change)="onPackageChange($event)" name="package">
                <option value="" disabled selected>Select Package</option>
                <option value="{{package.packageUid}}" *ngFor="let package of allPackages">{{package.packageName}}
                </option>
            </select>
            <span *ngIf="package && package.invalid && package.touched" style="color: red;">Please select the
                Package</span>
            <br>
            <!-- upc dropdown -->
            <select class="form-control" formControlName="formUpc" name="formUpc">
                <option value="" disabled selected>Select UPC code</option>
                <option value="{{code}}" *ngFor="let code of upcCode">{{code}}</option>
            </select>
            <span *ngIf="formUpc && formUpc.invalid && formUpc.touched" style="color: red;">Please select the UPC</span>
            <br>
            <!-- text area to scan serial numbers-->
            <textarea class="scan-box form-control" name="serial_number" formControlName="serial_number"
                style="width: 100%; min-height: 95px" placeholder="Scan here">
            </textarea>
            <span *ngIf="serial_number && serial_number.invalid && serial_number.touched" style="color: red;">Please
                scan the serial number</span>
            <br>
            <button class="btn btn-primary" type="submit" name="submit" value="Submit" [disabled]="scanForm.invalid"
                (click)="scannedSerialNumber()" style="width: 100%;">
                Scan Serial Numbers
            </button>
        </form>
    </div>
    <div class="col-md-3 third-column">
        <button type="button" class="btn btn-secondary" (click)="addPackagetoSerialNumberModal()" mat-raised-button
            data-target="#check_serial_no" style="width: 100%;">Add Serial Numbers to Pack</button>
        <!-- modal - checkbox serial numbers and mac addresses - Start-->
        <div class="modal" id="check_serial_no" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <label style="text-align:left; font-size: 15px; flex-grow: 1;">Add Serial Numbers</label>
                        <button type="button" (click)="closeAddPackagetoSerialNumberModal()" class="close btn-danger"
                            data-dismiss="modal" aria-label="Close"
                            style="width: 30px; height: 30px; text-align: center;">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div style="padding: unset;" *ngFor="let row of pickSerialNumbers" class="modal-body">
                        <p>
                            <mat-checkbox class="pickSerialNoCheckBox" [(ngModel)]="row.isChecked"
                                (change)="onCheckboxChange($event, row.serial_number, row.mac_address)">
                                Serial Number - {{ row.serial_number }}
                            </mat-checkbox>
                        </p>
                    </div>
                    <span [style.display]="isSelectPackageLabelVisible ? 'block' : 'none'" id="selectPackageLabel"
                        style="display: none; color: red">Please select the package to be assigned</span>
                    <div class="modal-footer" style="padding: 6px !important;">
                        <button type="button" mat-raised-button
                            style="width: 100px; height: 40px;align-self: center; box-shadow: 0 2px 8px rgb(0 0 0 / 20%);"
                            (click)="closeAddPackagetoSerialNumberModal()" class="btn"
                            data-dismiss="modal">Close</button>
                        <button type="button" style="width: 151px; height: 40px;align-self: center;" mat-raised-button
                            (click)="addPackagetoPickSerialNumbers()">Add to Package</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- modal - checkbox serial numbers and mac addresses - End-->
    </div>
    <div class="col-md-3 forth-column">
        <div class="vertical-line"></div>
        <div class="stepper-dot" style="display: grid;">
            <!-- scan -->
            <div style="min-height: 30px;">
                <img src="../assets/dot-circle.svg" id="scan-stepper" style="margin-right: 10px;">
                <label><b>SCAN STATUS</b></label>
            </div>
            <!-- pack -->
            <div style="min-height: 30px;">
                <img src="../assets/dot-circle.svg" id="pack-stepper" style="margin-right: 10px;">
                <label><b>PACK STATUS</b></label>
            </div>
            <!-- track -->
            <div (click)="showAddTrackingNumberModal()" style="min-height: 30px;">
                <div class="tooltip-button">
                    <div class="tooltip">Click to add new track</div>
                    <img src="../assets/dot-circle.svg" id="track-stepper" style="margin-right: 10px;">
                </div>
                <label style="cursor: pointer;"><b>TRACK STATUS</b></label>
            </div>

            <!-- print -->
            <div style="min-height: 30px;">
                <img src="../assets/download.svg" (click)="shipAndPrint()" style="width: 6vw;">
                <label><b>Print Shipping Information</b></label>
            </div>
            <!-- ready for oss -->
            <!-- <div style="min-height: 30px;">
                <img src="../assets/dot-circle.svg" id="ready-oss-stepper">
                <label>Ready for OSS</label>
            </div> -->

            <!-- if all packages are not assigned with tracking number or all serial# are not assigned with packages the button will be disabled -->
            <button mat-raised-button class="disabled" id="patch" name="patch" value=""
                style="width: max(3vw, 174px); height: 45px; margin-left: 2px;">
                Submit to OSS
            </button>

            <!-- modal - tracking number - Start-->
            <div class="modal" id="addTrackingNumberModal" tabindex="-1" role="dialog"
                aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <label style="font-size: 15px; text-align: left; flex-grow: 1;">Add Tracking Number</label>
                            <button type="button" class="close btn-danger" (click)="closeAddTrackingNumberModal()"
                                data-dismiss="modal" aria-label="Close" style="text-align: right;">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <form [formGroup]="addTrackingNumberForm" (ngSubmit)="addTrackingNumber()">
                                <!-- select package which will be assigned to tracking number -->
                                <select class="btn package-dropdown" formControlName="package"
                                    name="addTrackNumberPackage"
                                    style="height: 40px; width: 100%; border: 1px solid lightgray;">
                                    <option value="" disabled selected>Select Package</option>
                                    <option value="{{ package.packageUid }}" *ngFor="let package of allPackages">
                                        {{ package.packageName }}
                                    </option>
                                </select>
                                <span *ngIf="package && package.invalid && package.touched" style="color: red;">Please
                                    select the package</span>
                                <br><br>
                                <!-- insert new tracking number -->
                                <input class="form-control" formControlName="newTrackingNumber" name="newTrackingNumber"
                                    placeholder="Tracking Number" type="textbox" style="height: 40px;">
                                <span
                                    *ngIf="newTrackingNumber && newTrackingNumber.invalid && newTrackingNumber.touched"
                                    style="color: red">Insert tracking number</span>
                                <br>
                                <div class="modal-footer" style="padding: 6px !important;">
                                    <button type="button" (click)="closeAddTrackingNumberModal()"
                                        style="width: 100px; height: 40px;align-self: center; box-shadow: 0 2px 8px rgb(0 0 0 / 20%);"
                                        class="btn" data-dismiss="modal">Close</button>
                                    <button type="button" style="width: 155px; height: 40px;align-self: center;"
                                        [disabled]="addTrackingNumberForm.invalid" (click)="addTrackingNumber()"
                                        class="btn btn-primary">Assign to Package</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!-- modal - tracking number - End-->
        </div>
        <div class="progress-div">
            <p>Serial Numbers Scanned</p>
            <mat-progress-spinner class="progress-div" [color]="color" [mode]="mode" [value]="progressValue">
            </mat-progress-spinner>
            <span style="font-weight: bold; font-size: xxx-large; color: darkgreen;">
                {{ progressValue }}%
            </span>
        </div>
    </div>
</div>
<app-order-details-table #orderDetailsTableComponent [orderId]="orderId" [upc]="upcCode"></app-order-details-table>